/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef CREATE_LOG_ENTRY_HH_46597AE5B9074072B82EF7CCAC9DCA78
#define CREATE_LOG_ENTRY_HH_46597AE5B9074072B82EF7CCAC9DCA78

#include "src/log_entry.hh"
#include "src/log_entry_ident.hh"
#include "src/session_ident.hh"

#include "libpg/pg_rw_transaction.hh"

#include <boost/optional.hpp>

#include <string>
#include <vector>

namespace Fred {
namespace Logger {

struct CreateLogEntryRequest
{
    boost::optional<LogEntry::SourceIp> ip;
    LogEntry::ServiceName log_entry_service;
    boost::optional<LogEntry::Content> log_entry_content;
    std::vector<LogEntryProperties> log_entry_properties;
    std::vector<ObjectReferences> object_references;
    LogEntry::LogEntryTypeName log_entry_type;
    boost::optional<SessionIdent> session_ident;
};

struct CreateLogEntryReply
{
    LogEntryIdent log_entry_ident;
};

CreateLogEntryReply create_log_entry(
        const LibPg::PgRwTransaction& _rw_transaction,
        const boost::optional<LogEntry::SourceIp>& _ip,
        const LogEntry::ServiceName& _log_entry_service,
        const boost::optional<LogEntry::Content>& _log_entry_content,
        const std::vector<LogEntryProperties>& _log_entry_properties,
        const std::vector<ObjectReferences>& _object_references,
        const LogEntry::LogEntryTypeName& _log_entry_type,
        const boost::optional<SessionIdent>& _session_ident);

} // namespace Fred::Logger
} // namespace Fred

#endif
