/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef HANDLE_REQUEST_HH_38C3811FBE664B2695388F2D21D51244
#define HANDLE_REQUEST_HH_38C3811FBE664B2695388F2D21D51244

#include "src/create_log_entry.hh"
#include "src/close_log_entry.hh"
#include "src/create_session.hh"
#include "src/close_session.hh"
#include "src/get_log_entry_types.hh"
#include "src/get_services.hh"
#include "src/get_results.hh"
#include "src/get_object_reference_types.hh"
#include "src/get_log_entry_info.hh"
#include "src/list_log_entries.hh"

namespace Fred {
namespace Logger {

CreateLogEntryReply handle_request(const CreateLogEntryRequest& _request);

void handle_request(const CloseLogEntryRequest& _request);

CreateSessionReply handle_request(const CreateSessionRequest& _request);

void handle_request(const CloseSessionRequest& _request);

GetLogEntryTypesReply handle_request(const GetLogEntryTypesRequest& _request);

GetServicesReply handle_request(const GetServicesRequest& _request);

GetResultsReply handle_request(const GetResultsRequest& _request);

GetObjectReferenceTypesReply handle_request(const GetObjectReferenceTypesRequest& _request);

GetLogEntryInfoReply handle_request(const GetLogEntryInfoRequest& _request);

ListLogEntriesReply handle_request(const ListLogEntriesRequest& _request);

} // namespace Fred::Logger
} // namespace Fred

#endif
