/*
 * Copyright (C) 2019-2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef PROTO_UNWRAP_HH_A1CE82340F4A42558C763705118AA11B
#define PROTO_UNWRAP_HH_A1CE82340F4A42558C763705118AA11B

#include "src/close_log_entry.hh"
#include "src/close_session.hh"
#include "src/create_log_entry.hh"
#include "src/create_session.hh"
#include "src/get_log_entry_info.hh"
#include "src/get_log_entry_types.hh"
#include "src/get_object_reference_types.hh"
#include "src/get_results.hh"
#include "src/get_services.hh"
#include "src/list_log_entries.hh"

#include "fred_api/logger/service_logger_grpc.pb.h"
#include "fred_api/logger/service_search_logger_history_grpc.pb.h"

namespace Fred {
namespace Logger {

CreateLogEntryRequest proto_unwrap(const Api::CreateLogEntryRequest& _request);

CloseLogEntryRequest proto_unwrap(const Api::CloseLogEntryRequest& _request);

CreateSessionRequest proto_unwrap(const Api::CreateSessionRequest& _request);

CloseSessionRequest proto_unwrap(const Api::CloseSessionRequest& _request);

GetLogEntryTypesRequest proto_unwrap(const Api::GetLogEntryTypesRequest& _request);

GetResultsRequest proto_unwrap(const Api::GetResultsRequest& _request);

ListLogEntriesRequest proto_unwrap(const Api::ListLogEntriesRequest& _request);

GetLogEntryInfoRequest proto_unwrap(const Api::GetLogEntryInfoRequest& _src);

} // namespace Fred::Logger
} // namespace Fred

#endif
